unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Shape1: TShape;
    Timer1: TTimer;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    x,y   : integer;
    dx,dy : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  x := Shape1.Left + Shape1.Width  div 2;
  y := Shape1.Top  + Shape1.Height div 2;

  dx := 5;
  dy := 8;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Timer1.Enabled := true;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Timer1.Enabled := false;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  x := x + dx;
  y := y + dy;

  with Shape1 do begin
    // mov. izquierda-derecha
    Left := x - Width  div 2;
    if (Left + Width) > Panel2.Left then begin
      dx := -dx;
      x  := x + dx;
    end;
    if Left  <  Panel1.Left + Panel1.Width then begin
      dx := -dx;
      x  := x + dx;
    end;

    // mov. arriba-abajo
    Top := y - Height  div 2;
    if Top  < Panel3.Top + Panel3.Height then begin
      dy := -dy;
      y  := y + dy;
    end;
    if Top + Height >  Panel4.Top  then begin
      dy := -dy;
      y  := y + dy;
    end;

  end;

end;


end.
